c INTERRPT.INC : include file for INTRPT and INTRPTX.
c  This file includes the INTERFACE to the assember routines and the
c  register structures needed for these routines


      INTERFACE TO SUBROUTINE INTERRUPT (intnum,inregs,outregs)  
      structure /regs/  
          integer*2 ax,bx,cx,dx,si,di,flags  
      end structure  
      integer*2 intnum 
      record /regs/ inregs  [REFERENCE]   ! Regs into INTERRUPT  
      record /regs/ outregs [REFERENCE]   ! Regs returned  
      end  
  
      INTERFACE TO SUBROUTINE INTERRUPTX (intnum,inregsX,outregsX)  
      structure /regsX/  
          integer*2 ax,bx,cx,dx,si,di,es,ds,flags  
      end structure  
      integer*2 intnum 
      record /regsX/ inregsX   [REFERENCE] ! Regs into INTERRUPTX  
      record /regsX/ outregsX  [REFERENCE] ! Regs returned  
      end  
 
      implicit integer (a-g) 
 
      structure /wordregs/                  ! Full word registers  
          integer*2 ax,bx,cx,dx,si,di,flags
      end structure  

      structure /wordregsX/                  ! Full word registers  
          integer*2 ax,bx,cx,dx,si,di,es,ds,flags
      end structure  
  
 
      integer*2 intnum                      ! Interrupt number

      record /wordregs/ inregs,outregs  
      record /wordregsX/ inregsX,outregsX  

c Copy these function statements after your other declarations
c but before other executable statement in the program, subroutine
c or function in which you call INTERRUPT or INTERRUPTX.
c      gethibyte (dataword) = dataword / 256 
c      getlobyte (dataword) = iand(dataword , 255) 
 
